/***************************************************************************
            Tab stripper - by Les Kneeling, 1990
***************************************************************************/
#include <osbind.h>
#include <stdio.h>
#include <strings.h>

FILE *input, *output;

main( argc, argv )      /* Needs to have input and output filenames */
int argc;               /* supplied to it                           */
char **argv;
{
if( (argc != 3) )           /* Not the right number of parameters   */
    {                               /* display error message        */
    Cconws( "Usage: DE_TAB INPUT.FIL OUTPUT.FIL");
    exit(1);                        /* and quit                     */
    }
if( !open_input( argv[1] ))         /* Can't open input file        */
    {                               /* display error message        */
    puts( "ERROR opening input file");
    exit(1);                        /* and quit                     */
    };
if( !open_output( argv[2]) )        /* Can't open output file       */
    {                               /* display error message        */
    puts( "ERROR opening output file");
    fclose( input );                /* tidy up                      */
    exit(1);                        /* and quit                     */
    }
puts("Starting conversion");        /* Show program is working      */
convert();
fclose( input );
fclose( output );                   /* Finished                     */
}

int open_input( fname )             /* Open input file              */
char *fname;
{
input = fopen( fname, "r" );
return input != 0l;
}

int open_output( fname )            /* Open output file             */
char *fname;
{
output = fopen( fname, "w" );
return input != 0l;
}

convert()                           /* Process the file             */
{
int out_count = 0;
char offset, oc;
char letter;

letter = fgetc( input );                /* Get first letter         */
while( !feof( input ) )
    {
    if( letter == 9 )                   /* Is it a tab?             */
        {
        offset = 4-(out_count%4);       /* Work out how many spaces */
        for (oc=0; oc < offset ; oc++)  /* are needed to replace it */
            {
            fputc( 32, output );        /* output the spaces        */
            Bconout( 2, 32 );
            }
        out_count += offset;
        }
    else if( letter == 0x0d )           /* Is it an CR              */
        {
        out_count = 0;                  /* Yes - clear count        */
        }
    else if( letter == 0x0a )           /* or a line feed           */
            {
            fputc( letter, output );
            puts("");                   /* EOL for screen display   */
            out_count = 0;              /* and reset count          */
            }
    else                                /* Ordinary letter          */
        {
        fputc( letter, output );        /* send it to file          */
        out_count++;                    /* count it                 */
        Bconout( 2, letter );           /* Put it on the screen     */
        }
    if( out_count > 79 )                /* Do a line feed if the    */
        {                               /* line is too long         */
        fputc( 13, output );
        Bconout( 2, 0x0a );
        Bconout( 2, 0x0d );
        out_count = 0;                  /* clear count              */
        }
    letter = fgetc( input );            /* get next letter          */
    }
}
